package;

class Permutation {
	private var result = [];

	private var total:Int;
	private var callBack:Array<Array<Int>>->Void;

	public function new(arr:Array<Int>, callBack:Array<Array<Int>>->Void) {
		var i = arr.length;
		var total = 1;

		while (i > 0) {
			total *= i;
			i--;
		}
		this.total = total;
		this.callBack = callBack;

		heapPermutation(arr, arr.length, arr.length);
	}

	private function heapPermutation(a:Array<Int>, size:Int, n:Int) {
		if (size == 1) {
			// trace(a);
			result.push(a.slice(0));
			if (result.length == total) {
				callBack(result);
			}
		}

		for (i in 0...size) {
			heapPermutation(a, size - 1, n);

			if (size % 2 == 1) {
				var temp = a[0];
				a[0] = a[size - 1];
				a[size - 1] = temp;
			} else {
				var temp = a[i];
				a[i] = a[size - 1];
				a[size - 1] = temp;
			}
		}
	}
}
